package arbre;

/**
 * 
 * @author santini
 * 
 * Définition et gestion d'un noeud.
 *
 */
public class Noeud {
	
	private final String nom;
	private final Integer coeff;
	private Integer valeur;
	
	/**
	 * Constructeur Champ à champ.
	 * @param n le nom du noeud.
	 * @param v la valeur du noeud.
	 * @param c le coefficient du noeud.
	 */
	public Noeud(String n, Integer v, Integer c) {
		this.nom = n;
		this.valeur = v;
		this.coeff = c;
	}

	/**
	 * Getter de la valeur du noeud.
	 * @return la valeur du noeud.
	 */
	public Integer getValeur() {
		return valeur;
	}

	public void setValeur(Integer valeur) {
		this.valeur = valeur;
	}

	/**
	 * Getter du nom du noeud.
	 * @return le nom du noeud.
	 */
	public String getNom() {
		return nom;
	}

	/**
	 * Getter du coefficient du noeud.
	 * @return le coefficient du noeud.
	 */
	public Integer getCoeff() {
		return coeff;
	}
	
	/**
	 * Représentation textuelle d'un noeud.
	 * @return la chaîne de caractère représentant l'état d'un noeud..
	 */
	public String toString() {
		return "(" + this.getNom() + " ," + this.getValeur() + ", " + this.getCoeff() + ")";
	}
	
	/**
	 * Mise à jour d'un noeud lors de l'incidence d'une valeur.
	 * @param v la valeur incidente.
	 */
	public void majValeur(Integer v) {
		this.setValeur(this.getValeur() + this.getCoeff() * v);
	}
}