package arbre;

/**
 * 
 * @author santini
 * 
 * Définition et gestion d'un noeud feuille.
 *
 */
public class NoeudIntermediaire extends NoeudRacine implements Observateur {

	/**
	 * Constructeur champ à champ.
	 * @param n le nom du noeud intermédiaire.
	 * @param v la valeur du noeud intermédiaire.
	 * @param c le coefficient du noeud intermédiaire.
	 * @param s le noeud parent auquel le noeud intermédiaire s'abonne pour être notifié de ses changements d'état.
	 */
	public NoeudIntermediaire(String n, Integer v, Integer c, Sujet s) {
		super(n, v, c);
		s.ajouterObservateur(this);
	}

	/**
	 * Actualise le noeud intermédiaire lorsque Sujet s change d'état.
	 * @param s le noeud parent auquel le noeud feuille s'est abonné pour être notifié de ses changements d'état et notifie ses noeuds enfants de son propre changement d'état.
	 */
	@Override
	public void actualiser(Sujet s) {
		if (s instanceof NoeudRacine) {
			this.majValeur(((NoeudRacine)s).getValeur());
		}
	}

}
