package arbre;

public interface Sujet {
	/**
	 * Ajoute un observateur au sujet
	 * @param o l'observateur à ajouter s'abonnant aux notifications de modification de l'état du sujet.
	 */
	public abstract void ajouterObservateur(Observateur o) ;
	
	/**
	 * Supprime un des observateurs de sujet
	 * @param o l'observateur à supprimer se désabonnant des notifications de modification de l'état du sujet.
	 */
	public abstract void supprimerObservateur(Observateur o) ;
	
	/**
	 * Notifie à tous les abonnés d'une modification de l'état du sujet.
	 */
	public abstract void notifierObservateurs() ;
}
